/*
 * zen/include/test.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \chapter{An example of user program, the test of the library.}
   }
   */

/* \TEX{
   \Section{Choices by default.}
   }
   \CiteC
   */

#define FINITE_FIELD TRUE

#define NB_RG 3
				/* Chinese case */
#define ZEC_NB_RG 2
#define ZEC_NB_BASE 5
#define ZEC_NB_EXT  3
#define ZEC_NB_TOTRG (ZEC_NB_BASE+1+ZEC_NB_EXT)

#define DEG_ZEN_EXT		0
#define NB_ZEN_ELT_ALLOC	1 
#define NB_ZEN_ELT_TEST		2 
#define MAX_ZEN_ELT_NEXT	3 
#define NB_ZEN_ELT_NEXT		4 
#define NB_ZEN_ELT_ADD		5 
#define NB_ZEN_ELT_NEGATE	6 
#define NB_ZEN_ELT_SUBTRACT	7 
#define NB_ZEN_ELT_MULTIPLY	8 
#define NB_ZEN_ELT_SQUARE	9 
#define NB_ZEN_ELT_INVERSE	10 
#define NB_ZEN_ELT_TRACE	11 
#define NB_ZEN_ELT_PR_STRING	12 
#define NB_ZEN_ELT_PR_FILE	13 
#define NB_ZEN_ELT_PG_STRING	14 
#define NB_ZEN_ELT_PG_FILE	15
#define NB_ZEN_ELT_EXP  	16
#define NB_ZEN_ELT_TO_Z  	17

#define NB_LN_ELT               18

#define MAX_ZEN_POLY_DEG	0 
#define NB_ZEN_POLY_ALLOC	1 
#define NB_ZEN_POLY_TEST	2
#define NB_ZEN_POLY_COEFF	3
#define NB_ZEN_POLY_UPDATE	4
#define NB_ZEN_POLY_ADD		5
#define NB_ZEN_POLY_NEGATE	6
#define NB_ZEN_POLY_SUBTRACT	7
#define NB_ZEN_POLY_EVAL	8
#define NB_ZEN_POLY_MULTIPLY	9
#define NB_ZEN_POLY_SQUARE      10
#define NB_ZEN_POLY_DIVIDE	11
#define NB_ZEN_POLY_PR_STRING   12
#define NB_ZEN_POLY_PR_FILE	13
#define NB_ZEN_POLY_PG_STRING	14
#define NB_ZEN_POLY_PG_FILE     15

#define NB_LN_POLY              16

#define MAX_ZEN_MAT_DEG		0
#define NB_ZEN_MAT_ALLOC	1
#define NB_ZEN_MAT_TEST	        2
#define NB_ZEN_MAT_COEFF	3
#define NB_ZEN_MAT_ADD		4
#define NB_ZEN_MAT_NEGATE	5
#define NB_ZEN_MAT_SUBTRACT	6
#define NB_ZEN_MAT_MULTIPLY	7
#define NB_ZEN_MAT_WINOGRAD     8
#define NB_ZEN_MAT_GAUSS	9
#define NB_ZEN_MAT_KERNEL       10
#define NB_ZEN_MAT_PR_STRING    11
#define NB_ZEN_MAT_PR_FILE	12
#define NB_ZEN_MAT_PG_STRING	13
#define NB_ZEN_MAT_PG_FILE      14
#define NB_ZEN_MAT_CONVERT      15
#define NB_ZEN_POLY_FACTOR      16

#define NB_LN_MAT               17

#define MAX_ZEN_SR_DEG	        0
#define NB_ZEN_SR_ALLOC	        1
#define NB_ZEN_SR_TEST	        2
#define NB_ZEN_SR_COEFF	        3
#define NB_ZEN_SR_UPDATE	4
#define NB_ZEN_SR_ADD		5
#define NB_ZEN_SR_NEGATE	6
#define NB_ZEN_SR_SUBTRACT	7
#define NB_ZEN_SR_MULTIPLY	8
#define NB_ZEN_SR_SQUARE        9
#define NB_ZEN_SR_DIVIDE	10
#define NB_ZEN_SR_PR_STRING     11
#define NB_ZEN_SR_PR_FILE	12
#define NB_ZEN_SR_PG_STRING	13
#define NB_ZEN_SR_PG_FILE       14

#define NB_LN_SR                15

#define NB_ZEN_EC_ALLOC	        0
#define NB_ZEN_EC_TEST	        1
#define NB_ZEN_EC_ADD		2
#define NB_ZEN_EC_NEGATE	3
#define NB_ZEN_EC_SUBTRACT	4
#define NB_ZEN_EC_MULTIPLY      5
#define NB_ZEN_EC_PR_STRING     6
#define NB_ZEN_EC_PR_FILE	7
#define NB_ZEN_EC_PG_STRING	8
#define NB_ZEN_EC_PG_FILE       9

#define NB_LN_EC                10

/* \EndCiteC
   The c files of the library.
   \TEX{

   \include{zentest}
   \include{elt_test}
   \include{poly_test}
   \include{mat_test}
   \include{sr_test}
   \include{ec_test}

   }
*/
