/*
 * zen/include/zentest_zetab.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

#if ZEN_NO_TEST			/* fast tests */

int ZENELT_ZETAB_CSTS[NB_LN_ELT][NB_RG] = {
  {0, 2, 2},                    /* DEG_ZEN_EXT */
  {50, 50, 50},              /* NB_ZEN_ELT_ALLOC */
  {50, 50, 50},                 /* NB_ZEN_ELT_TEST */
  {100, 100, 100},           /* MAX_ZEN_ELT_NEXT */
  {10, 10, 10},                 /* NB_ZEN_ELT_NEXT */
  {50, 50, 10},              /* NB_ZEN_ELT_ADD */
  {100, 100, 100},              /* NB_ZEN_ELT_NEGATE */
  {100, 100, 100},              /* NB_ZEN_ELT_SUBTRACT */
  {100, 100, 100},             /* NB_ZEN_ELT_MULTIPLY */
  {100, 100, 100},             /* NB_ZEN_ELT_SQUARE */
  {100, 100, 100},             /* NB_ZEN_ELT_INVERSE */
  {100, 10, 10},                /* NB_ZEN_ELT_TRACE */
  {50, 50, 50},              /* NB_ZEN_ELT_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_ELT_PR_FILE */
  {50, 50, 50},              /* NB_ZEN_ELT_PG_STRING */
  {50, 50, 50},                 /* NB_ZEN_ELT_PG_FILE */
  {5, 5, 5},                     /* NB_ZEN_ELT_EXP */
  {50, 10, 5}                   /* NB_ZEN_ELT_TO_Z */
};

int ZENPOLY_ZETAB_CSTS[NB_LN_POLY][NB_RG] = {
  {50, 20, 10},                 /* MAX_ZEN_POLY_DEG */
  {20, 20, 20},                 /* NB_ZEN_POLY_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_POLY_TEST */
  {50, 50, 50},                 /* NB_ZEN_POLY_COEFF */
  {50, 50, 50},                 /* NB_ZEN_POLY_UPDATE */
  {100, 100, 50},              /* NB_ZEN_POLY_ADD */
  {100, 100, 50},              /* NB_ZEN_POLY_NEGATE */
  {100, 100, 50},              /* NB_ZEN_POLY_SUBTRACT */
  {100, 100, 50},              /* NB_ZEN_POLY_EVAL */
  {100, 50, 50},               /* NB_ZEN_POLY_MULTIPLY */
  {100, 50, 50},               /* NB_ZEN_POLY_SQUARE */
  {100, 50, 50},               /* NB_ZEN_POLY_DIVIDE */
  {50, 50, 50},               /* NB_ZEN_POLY_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_POLY_PR_FILE */
  {50, 50, 50},               /* NB_ZEN_POLY_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_POLY_PG_FILE */
};

int ZENMAT_ZETAB_CSTS[NB_LN_MAT][NB_RG] = {
  {20, 10, 5},                  /* MAX_ZEN_MAT_DEG */
  {80, 80, 80},                 /* NB_ZEN_MAT_ALLOC */
  {80, 80, 80},                 /* NB_ZEN_MAT_TEST */
  {80, 80, 80},                 /* NB_ZEN_MAT_COEFF */
  {80, 80, 80},                 /* NB_ZEN_MAT_ADD */
  {80, 80, 80},                 /* NB_ZEN_MAT_NEGATE */
  {80, 80, 80},                 /* NB_ZEN_MAT_SUBTRACT */
  {240, 160, 40},               /* NB_ZEN_MAT_MULTIPLY */
  {0, 80, 80},			/* NB_ZEN_MAT_WINOGRAD */
  {160, 160, 40},               /* NB_ZEN_MAT_GAUSS */
  {160, 160, 80},               /* NB_ZEN_MAT_KERNEL */
  {80, 80, 80},                 /* NB_ZEN_MAT_PR_STRING */
  {80, 80, 80},                 /* NB_ZEN_MAT_PR_FILE */
  {80, 80, 80},                 /* NB_ZEN_MAT_PG_STRING */
  {80, 80, 80},                 /* NB_ZEN_MAT_PG_FILE */
  {0,  80, 80},			/* NB_ZEN_MAT_CONVERT  */
  {20, 10, 5}                  /* NB_ZEN_POLY_FACTOR */
};

int ZENSR_ZETAB_CSTS[NB_LN_SR][NB_RG] = {
  {50, 20, 10},                 /* MAX_ZEN_SR_DEG */
  {20, 20, 20},                 /* NB_ZEN_SR_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_SR_TEST */
  {50, 50, 50},                 /* NB_ZEN_SR_COEFF */
  {50, 50, 50},                 /* NB_ZEN_SR_UPDATE */
  {50, 50, 50},              /* NB_ZEN_SR_ADD */
  {50, 50, 50},              /* NB_ZEN_SR_NEGATE */
  {50, 50, 50},              /* NB_ZEN_SR_SUBTRACT */
  {50, 50, 50},               /* NB_ZEN_SR_MULTIPLY */
  {50, 50, 50},               /* NB_ZEN_SR_SQUARE */
  {50, 50, 50},               /* NB_ZEN_SR_DIVIDE */
  {50, 50, 50},               /* NB_ZEN_SR_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_SR_PR_FILE */
  {50, 50, 50},               /* NB_ZEN_SR_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_SR_PG_FILE */
};

int ZENEC_ZETAB_CSTS[NB_LN_SR][NB_RG] = {
  {20, 20, 20},                 /* NB_ZEN_EC_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_EC_TEST */
  {100, 10, 10},                /* NB_ZEN_EC_ADD */
  {100, 10, 10},                /* NB_ZEN_EC_NEGATE */
  {100, 10, 10},                /* NB_ZEN_EC_SUBTRACT */
  {100, 10, 10},                /* NB_ZEN_EC_MULTIPLY */
  {50, 50, 50},               /* NB_ZEN_EC_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_EC_PR_FILE */
  {50, 50, 50},               /* NB_ZEN_EC_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_EC_PG_FILE */
};

#else  /* debugging tests */

int ZENELT_ZETAB_CSTS[NB_LN_ELT][NB_RG] = {
  {0, 2, 2},                    /* DEG_ZEN_EXT */
  {500, 500, 500},              /* NB_ZEN_ELT_ALLOC */
  {50, 50, 50},                 /* NB_ZEN_ELT_TEST */
  {1000, 1000, 1000},           /* MAX_ZEN_ELT_NEXT */
  {10, 10, 10},                 /* NB_ZEN_ELT_NEXT */
  {500, 500, 100},              /* NB_ZEN_ELT_ADD */
  {100, 100, 100},              /* NB_ZEN_ELT_NEGATE */
  {100, 100, 100},              /* NB_ZEN_ELT_SUBTRACT */
  {1000, 500, 100},             /* NB_ZEN_ELT_MULTIPLY */
  {1000, 500, 100},             /* NB_ZEN_ELT_SQUARE */
  {1000, 500, 100},             /* NB_ZEN_ELT_INVERSE */
  {100, 10, 10},                /* NB_ZEN_ELT_TRACE */
  {200, 200, 200},              /* NB_ZEN_ELT_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_ELT_PR_FILE */
  {200, 200, 200},              /* NB_ZEN_ELT_PG_STRING */
  {50, 50, 50},                 /* NB_ZEN_ELT_PG_FILE */
  {5, 5, 5},                     /* NB_ZEN_ELT_EXP */
  {50, 10, 5}                   /* NB_ZEN_ELT_TO_Z */
};

int ZENPOLY_ZETAB_CSTS[NB_LN_POLY][NB_RG] = {
  {50, 20, 10},                 /* MAX_ZEN_POLY_DEG */
  {20, 20, 20},                 /* NB_ZEN_POLY_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_POLY_TEST */
  {50, 50, 50},                 /* NB_ZEN_POLY_COEFF */
  {50, 50, 50},                 /* NB_ZEN_POLY_UPDATE */
  {200, 500, 500},              /* NB_ZEN_POLY_ADD */
  {200, 200, 200},              /* NB_ZEN_POLY_NEGATE */
  {200, 200, 200},              /* NB_ZEN_POLY_SUBTRACT */
  {200, 200, 200},              /* NB_ZEN_POLY_EVAL */
  {100, 50, 200},               /* NB_ZEN_POLY_MULTIPLY */
  {100, 50, 200},               /* NB_ZEN_POLY_SQUARE */
  {200, 50, 200},               /* NB_ZEN_POLY_DIVIDE */
  {200, 100, 50},               /* NB_ZEN_POLY_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_POLY_PR_FILE */
  {200, 100, 50},               /* NB_ZEN_POLY_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_POLY_PG_FILE */
};

#if 1
int ZENMAT_ZETAB_CSTS[NB_LN_MAT][NB_RG] = {
  {20, 10, 5},                  /* MAX_ZEN_MAT_DEG */
  {80, 80, 80},                 /* NB_ZEN_MAT_ALLOC */
  {80, 80, 80},                 /* NB_ZEN_MAT_TEST */
  {80, 80, 80},                 /* NB_ZEN_MAT_COEFF */
  {80, 80, 80},                 /* NB_ZEN_MAT_ADD */
  {80, 80, 80},                 /* NB_ZEN_MAT_NEGATE */
  {80, 80, 80},                 /* NB_ZEN_MAT_SUBTRACT */
  {240, 160, 40},               /* NB_ZEN_MAT_MULTIPLY */
  {1, 1, 1},			/* NB_ZEN_MAT_WINOGRAD */
  {240, 160, 40},               /* NB_ZEN_MAT_GAUSS */
  {160, 160, 80},               /* NB_ZEN_MAT_KERNEL */
  {80, 80, 80},                 /* NB_ZEN_MAT_PR_STRING */
  {80, 80, 80},                 /* NB_ZEN_MAT_PR_FILE */
  {80, 80, 80},                 /* NB_ZEN_MAT_PG_STRING */
  {80, 80, 80},                 /* NB_ZEN_MAT_PG_FILE */
  {0,  80, 80},			/* NB_ZEN_MAT_CONVERT  */
  {20, 10, 5}                  /* NB_ZEN_POLY_FACTOR */
};
#else
int ZENMAT_ZETAB_CSTS[NB_LN_MAT][NB_RG] = {
  {5, 10, 5},                  /* MAX_ZEN_MAT_DEG */
  {0, 80, 80},                 /* NB_ZEN_MAT_ALLOC */
  {0, 80, 80},                 /* NB_ZEN_MAT_TEST */
  {0, 80, 80},                 /* NB_ZEN_MAT_COEFF */
  {0, 80, 80},                 /* NB_ZEN_MAT_ADD */
  {0, 80, 80},                 /* NB_ZEN_MAT_NEGATE */
  {0, 80, 80},                 /* NB_ZEN_MAT_SUBTRACT */
  {0, 160, 40},               /* NB_ZEN_MAT_MULTIPLY */
  {0, 1, 1},			/* NB_ZEN_MAT_WINOGRAD */
  {80, 160, 40},               /* NB_ZEN_MAT_GAUSS */
  {80, 160, 80},               /* NB_ZEN_MAT_KERNEL */
  {0, 80, 80},                 /* NB_ZEN_MAT_PR_STRING */
  {0, 80, 80},                 /* NB_ZEN_MAT_PR_FILE */
  {0, 80, 80},                 /* NB_ZEN_MAT_PG_STRING */
  {0, 80, 80},                 /* NB_ZEN_MAT_PG_FILE */
  {0,  80, 80},			/* NB_ZEN_MAT_CONVERT  */
  {20, 10, 5}                  /* NB_ZEN_POLY_FACTOR */
};
#endif

int ZENSR_ZETAB_CSTS[NB_LN_SR][NB_RG] = {
  {50, 20, 10},                 /* MAX_ZEN_SR_DEG */
  {20, 20, 20},                 /* NB_ZEN_SR_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_SR_TEST */
  {50, 50, 50},                 /* NB_ZEN_SR_COEFF */
  {50, 50, 50},                 /* NB_ZEN_SR_UPDATE */
  {200, 500, 500},              /* NB_ZEN_SR_ADD */
  {200, 200, 200},              /* NB_ZEN_SR_NEGATE */
  {200, 200, 200},              /* NB_ZEN_SR_SUBTRACT */
  {200, 50, 200},               /* NB_ZEN_SR_MULTIPLY */
  {200, 50, 200},               /* NB_ZEN_SR_SQUARE */
  {200, 50, 200},               /* NB_ZEN_SR_DIVIDE */
  {200, 100, 50},               /* NB_ZEN_SR_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_SR_PR_FILE */
  {200, 100, 50},               /* NB_ZEN_SR_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_SR_PG_FILE */
};

int ZENEC_ZETAB_CSTS[NB_LN_SR][NB_RG] = {
  {20, 20, 20},                 /* NB_ZEN_EC_ALLOC */
  {10, 10, 10},                 /* NB_ZEN_EC_TEST */
  {200, 10, 10},                /* NB_ZEN_EC_ADD */
  {200, 10, 10},                /* NB_ZEN_EC_NEGATE */
  {200, 10, 10},                /* NB_ZEN_EC_SUBTRACT */
  {200, 10, 10},                /* NB_ZEN_EC_MULTIPLY */
  {200, 100, 50},               /* NB_ZEN_EC_PR_STRING */
  {50, 50, 50},                 /* NB_ZEN_EC_PR_FILE */
  {200, 100, 50},               /* NB_ZEN_EC_PG_STRING */
  {50, 50, 50}                  /* NB_ZEN_EC_PG_FILE */
};
#endif
