/*
 * zen/include/zer.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

#ifndef __ZER__
#define __ZER__


#include "zen.h"

extern int _Ze2Init ___((ZENRing));
extern int _ZefInit ___((ZENRing));
extern int _ZepInit ___((ZENRing));
extern int _ZepsInit ___((ZENRing));
extern int _ZextInit ___((ZENRing));
extern int _ZetabInit ___((ZENRing));
extern int _ZelogInit ___((ZENRing));
extern int _ZecInit ___((ZENRing));
extern int _ZefInit ___((ZENRing));
extern int _ZemInit ___((ZENRing));

extern int _Ze2Close ___((ZENRing));
extern int _ZepClose ___((ZENRing));
extern int _ZepsClose ___((ZENRing));
extern int _ZextClose ___((ZENRing));
extern int _ZetabClose ___((ZENRing));
extern int _ZelogClose ___((ZENRing));
extern int _ZecClose ___((ZENRing));
extern int _ZefClose ___((ZENRing));
extern int _ZemClose ___((ZENRing));

extern void __ZENPolyGeneric ___((ZENRing));
extern void __ZENMatGeneric ___((ZENRing));
extern void __ZENSrGeneric ___((ZENRing));
extern int __ZENBaseClose ___((ZENRing));
extern int __ZENExtClose ___((ZENRing));
extern int __ZENCloneClose ___((ZENRing));
extern int __ZENChineseClose ___((ZENRing));

extern ZENRing __ZENRingCreate ___((BigNum, BigNumLength));
extern int __ZENRingInitBuffers ___((ZENRing));


#define ZENRingDebugStruct(R) (R)->debug

#define ZBPPtr(R) ZENRingDebugStruct(R).ZENBP
#define ZBRPtr(R) ZENRingDebugStruct(R).ZENBR
#define ZEPPtr(R) ZENRingDebugStruct(R).ZENEP
#define ZFPPtr(R) ZENRingDebugStruct(R).ZENFP
#define ZERPtr(R) ZENRingDebugStruct(R).ZENER
#define ZPPPtr(R) ZENRingDebugStruct(R).ZENPP
#define ZPRPtr(R) ZENRingDebugStruct(R).ZENPR
#define ZMPPtr(R) ZENRingDebugStruct(R).ZENMP
#define ZMRPtr(R) ZENRingDebugStruct(R).ZENMR
#define ZSPPtr(R) ZENRingDebugStruct(R).ZENSP
#define ZSRPtr(R) ZENRingDebugStruct(R).ZENSR

extern int ZBP ___((BigNum, BigNumLength));
extern int ZBR ___((BigNum *, BigNumLength *));
extern int ZEP ___((ZENElt, ZENRing));
extern int ZFP ___((ZENElt, ZENRing));
extern int ZER ___((ZENElt, ZENRing));
extern int ZPP ___((ZENPoly, ZENRing));
extern int ZPR ___((ZENPoly *, ZENRing));
extern int ZMP ___((ZENMat, ZENRing));
extern int ZMR ___((ZENMat *, ZENRing));
extern int ZSP ___((ZENSr, ZENRing));
extern int ZSR ___((ZENSr *, ZENRing));

/* 
   \TEX{
   \Section{Default initialization functions}
   \input{zerring}

   \Section{Specific initialization functions}
   \input{zerbase_ring}
   \input{zerext_ring}
   \input{zerclone_ring}
   \input{zerchinese_ring}

   \Section{Input/output}
   \input{zerio}

   \Section{Tests}
   \input{zertest}

   \Section{Freeing memory}
   \input{zerclose}
   }
*/
#endif
