/*-*-LaTeX-*-
 * zen/inputs/advanced.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


\TEX{
\def\SubTitle{Advanced user manual}
\input{title}
\thispagestyle{headings}

\tableofcontents  

\Chapter{Improving programs}
  \Section{The programming environment}

  \input{prgenv}

%%%%%%%
  \Section{Implementation principles of |ZEN|.}

  \input{implement}

%%%%%%%% Extension Creation
  \Section{Ring initialization}
  \input{zerdoc}

  \Section{Extensions}
  \input{zextdoc}

  \Section{General functions}
  \input{zegdoc}

  \Section{Default functions}
  \input{zeddoc}

  \Section{Arithmetics}
  \Subsection{Modular rings}
  \input{zepdoc}

  \Subsection{Modular rings with small modulus}
  \input{zepsdoc}

  \Subsection{$\GF{2}$ case}
  \input{ze2doc}

  \Subsection{Rationals}
  \input{zefdoc}

  \Subsection{Clones}
  The purpose of clones is to perform when it is possible some precomputations in order to speed up arithmetic. These precomputations are made upon initialization and can take some time.
 Therefore, cloning can be efficient only if a lot of operations are performed.
 
  \Subsubsection{Tabulated clone}
  \input{zetabdoc}

  \Subsubsection{Logarithm clone}
  \input{zelogdoc}

  \Subsubsection{Use of chinese remainder theorem}
  \input{zecdoc}

\Chapter{Ring functions}
  \input{zer}

\Chapter{General functions}
  \input{zeg}

\Chapter{Default functions}
  \input{zed}

\Chapter{Extension functions}
  \input{zext}

\Chapter{Arithmetic over $\Z/2\Z$}
  \input{ze2}

\Chapter{Arithmetic over $\Z/p\Z$}
  \input{zep}

\Chapter{$\Z/n\Z$ with $n$ small}
  \input{zeps}

\Chapter{Tabulated clones}
  \input{zetab}

\Chapter{Clones with Zech's logarithms}
  \input{zelog}

\Chapter{Chinese remainder theorem}
  \input{zec}

\Chapter{Montgomery's representation}
  \input{zem}

\Chapter{Fractions}
  \input{zef}

  \Chapter{Testing the library}
  \input{elt_test}
  \input{poly_test}
  \input{mat_test}
  \input{sr_test}
  \input{ec_test}

  \appendix
  \input{index}
}
*/
