/*-*-LaTeX-*-
 * zen/inputs/implement.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


\TEX{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Improving programs %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%
  This section is subtitled ``How to write a new arithmetic'' as
  this is certainly the best way to understand the principles of |ZEN|. 

  An arithmetic can be mathematically defined by a set of elements
  that contains at least two elements 0 and 1, and two operations $+$
  and $\times$ verifying the classical properties. 

  Writing a new arithmetic will therefore consist in implementing these operations.
  Of course, technical reasons impose a much larger set of
  operations. In fact, the basic point is the initialization routine
  that will produce a |ZENRing| with all of the function pointers set
  to appropriate values. 

  Basically, all the |Elt| functions have to be specifically written
  for every new arithmetic.  For the remaining functions, one can
  first try the general functions of the |zed/| and |zeg/| directories
  that will provide operations on polynomials, matrices, series and
  elliptic curves, and therefore, allow extensions based on the new
  arithmetic.

  A modification of the |_ZENBaseRingCreate| function is also needed
  to take in account the modification. 
  Writing a new extension arithmetic is also possible --- for instance
  if you need very efficient operations on $\GF{33^3}$ and you know how
  to improve existing operations in this case --- but the above
  modification will of course take place in the |_ZENExtRingCreate|
  function 

  Eventually, other specific functions can be written to replace the
  |_ZEN| or |Zed| functions.
}
*/
