/*
 * zen/ze2/c/elt_alloc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \Subsection{Element creation}
   
   |_Ze2EltCreate| allocates one |ZENElt| and |_Ze2EltFree| frees then it.
   }
   */
#include <stdio.h>
#include "ze2.h"

/* \TEX[
   \title{Creation.}
   \input{A finite ring |Rg| and a pointer on a |ZENElt|.}
   \output{0.}
   }
   */
int _Ze2EltCreate(a, Rg)
     ZENElt *a;
     ZENRing Rg;
{
  Ze2EltCreate(*a, Rg);
  return(0);
}

/* \TEX[
   \title{Free.}
   \input{a |ZENElt| |a| of a finite ring |Rg| already allocated with
   |_Ze2EltCreate|.}
   \side{|a| is freed.}
   }
   */
void _Ze2EltFree(a,Rg)
     ZENElt a;
     ZENRing Rg;
{ 
  Ze2EltFree(a, Rg);
  return;
}
