/*
 * zen/ze2/c/elt_inverse.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
   \TEX{   
   \Subsection{Element inversion}
   
   |_Ze2EltInverse| computes the inverse of a |ZENElt|.
   }
   */
#include <stdio.h>
#include "ze2.h"

/* \TEX[
   \title{Inverse.}
   \input{A pointer |p_c| on a |ZENElt| and two |ZENElt| |a| and |b| of a
   finite ring |R|.}
   \output{|ZEN_HAS_INVERSE| if |a| has an inverse, |ZEN_NO_INVERSE| otherwise}
   \side{$|*p_c| = 1/a$ if |a| has an inverse, the gcd of |a| with the
   modulo otherwise.} 
   }
   */
int _Ze2EltInverse(p_c, a, R)
     ZENElt *p_c, a;
     ZENRing R;
{
  return(Ze2EltInverse(*p_c, a, R));
}
