/*
 * zen/ze2/c/poly_derivative.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
   \TEX{
   \Subsection{Derivation of a polynomial}
   } 
   */
#include <stdio.h>
#include "ze2.h"

/*
   \TEX[
   \title{Compute the derivative of a polynomial}
   \input{A pointer on a |ZENPoly| and a |ZENPoly| over a |ZENRing|.}
   \output{0}
   \side{$|D|(X)=|P|'(X)$.}
   } 
   */
int _Ze2PolyDerive(D,P,R)
     ZENPoly D,P;
     ZENRing R;
{ 
  int ds;

  for(ds = divSizeBloc(Ze2PolyDeg(P,R)); ds >= 0; ds--) {
    /* 10101010...10101010 */
#if !defined(i486icc) && !defined(sparc)
    if (SIZE_BLOC == LN2PREZENMULT<<3) {
      Ze2PolyGetDigit(D,ds,R) = Ze2PolyGetDigit(P,ds,R) & 12297829382473034410uL;
    }
    else 
#endif
      Ze2PolyGetDigit(D,ds,R) = Ze2PolyGetDigit(P,ds,R) & ((BigNumDigit)2863311530uL);
  }
  ZBNShiftRight(Ze2PolyDigit(D, R), divSizeBloc(Ze2PolyDeg(P,R))+1, 1);
  if (Ze2PolyDeg(P,R)) {
    Ze2PolyDeg(D,R) = Ze2PolyDeg(P,R)-1;
  }
  Ze2PolyUpdateDegree(D, R);
  return(0);
}

