/*
 * zen/zec/c/doc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*-*-LaTeX-*-
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


\TEX{
A |ZENRing| can be built upon two |ZENRing|s using the Chinese remainder theorem.
\paragraph*{Theorem}
{\em
Let $m$ and $n$ be two natural integers, $m$ prime with $n$.
The two rings $\quotient{\Z}{(mn)\Z}$ and $\quotient{\Z}{m\Z}\times\quotient{\Z}{n\Z}$ are isomorphic.
More precisely, the application
$$
\begin{array}{rcrcl}
\theta & : & \quotient{\Z}{mn\Z} & \rightarrow & \quotient{\Z}{m\Z} \times \quotient{\Z}{n\Z} \\
       &   & x       & \mapsto     & (x \bmod m, x \bmod n)
\end{array}
$$
is isomorphic and its reciprocal is
$$
\theta^{-1}(x_m,x_n) = x_m n (n^{-1}\bmod m) + x_n m (m^{-1}\bmod n) \bmod mn.
$$ 
}
The same kind of result can be stated for polynomials.

The implementation of these results in |ZEN| is more general: one can use $N$ |ZENRings| to build the two isomorphics |ZENRing|s.
 The $N$ |ZENRing|s must be of same level ($N$ modular rings, or $N$ extensions over same ring).
The representation of an element in such a ring, is the $N$-array of the $N$ projections of this element in the $N$ subrings.

The function |ZENChineseRingCreate()| performs such a construction.

}
*/





