/*
 * zen/zelog/c/doc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*-*-LaTeX-*-
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


\TEX{

  A small finite field $\F$ can be cloned using the logarithm
  representation.  The first operation performed is to find a
  generator $\alpha$ of the finite field.  Then, a table of all the
  logarithms is computed.  The adopted representation in |ZEN| is the
  following:
  \begin{center}
    \begin{tabular}{c@{ $\mapsto$ }c}
      Element of $\F$ & |ZEN| representation \\ \hline
      0 & 0 \\
      1 & 1 \\
      $\alpha$ & 2 \\
      $\alpha^i$ & $i+1$ 
    \end{tabular}
  \end{center}
  Hence, multiplication and inversion are easily performed by a
  modular addition on the exponent, assuming that a first test of
  equality to zero is performed on each operand:
  \begin{center}
    \begin{tabular}{c@{ $\mapsto$ }c}
      $\alpha^i \times \alpha^j$ & $(i+1)+(j+1)-1$ \\
      $(\alpha^i)^{-1}$ & $-(i+1)+2$
    \end{tabular}
  \end{center}
  For negation, the table of this operation is computed at the
  initialization of the clone.  For addition, another table is
  computed that stores all the exponent of each element incremented by
  one.  Addition of two elements can then be performed by a
  multiplication using the formula
  $$
  \alpha^i+\alpha^j=\alpha^i(1+\alpha^{j-i}).
  $$ The limit size is that of an |unsigned short|, that is to say at
  most 65536 elements.  Polynomials and matrices use also the same
  representation which saves memory.
  }

*/




