/*
 * zen/zelog/c/elt_add.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \Subsection{Element additions}
   
   |_ZelogEltAdd| enable us to add a |ZENElt| to another.
   }
   */
#include <stdio.h>
#include "zelog.h"

/* \TEX{
   \title{Addition.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| += |a|.}
   }
   */
void _ZelogEltAdd(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZelogEltAdd(*p_c, a, Rg);
}

/* \TEX{
   \title{Negation.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| = -|a|.}
   }
   */
void _ZelogEltNegate(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{

  ZelogEltNegate(*p_c, a, Rg);
}


/* \TEX{
   \title{Subtract.}
   \input{A pointer |p_c| on a |ZENElt| and a |ZENElt| |a| of a finite ring
   |Rg|.}
   \side{|*p_c| -= |a|.}
   }
   */
void _ZelogEltSubtract(p_c, a, Rg)
     ZENElt *p_c, a;
     ZENRing Rg;
{
  ZelogEltSubtract(*p_c, a, Rg);
}
