/*
 * zen/zep/c/elt_test.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_ZepEltAreEqual| to test if two
   |ZENElt| are equal, |_ZepEltIsZero| to test if a |ZENelt| is equal to
   zero, |_ZepEltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "zep.h"

/* \TEX{
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |R|.}
   \output{|a| == |b|.}
   }
   */
int _ZepEltAreEqual(a,b,R)
     ZENElt a, b;
     ZENRing R;
{
  return(ZepEltAreEqual(a,b,R));
}

/* \TEX{
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |R|.}
   \output{|a| == 0.}
   }
   */
int _ZepEltIsZero(a, R)
     ZENElt a;
     ZENRing R;
{
  return(ZepEltIsZero(a, R));
}

/* \TEX{
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |R|.}
   \output{|a| == 1.}
   }
   */
int _ZepEltIsOne(a, R)
     ZENElt a;
     ZENRing R;
{
  return(ZepEltIsOne(a, R));
}
