/*
 * zen/zeps/c/doc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*-*-LaTeX-*-
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


\TEX{
When the modulus is small, it is unefficient to use the heavy |BigNum| representation.
The arithmetic |zeps| provides modular arithmetic when the modulus fits in a single computer word (|BigNumDigit|).
It is called by |ZENBaseRingCreate()| function when this condition is true, that is to say when the modulus is strictly less than the following bounds:
\begin{center}
\begin{tabular}{rl}
65536 & for a 16-bits computer, (but we have never \\
      & tested the library in this case) \\ 
4294967296 & for a 32-bits computer, \\
18446744073709551616 & for a 64-bits computer. 
\end{tabular}
\end{center}
In this arithmetic, an element is also stored as a |BigNumDigit| and the operations are mainly the modular operations provided by the standard |C| syntax.
}
*/
