/*
 * zen/zeps/c/elt_alloc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \Subsection{Element creation}
   
   |_ZepsEltCreate| allocates one |ZENElt| and |_ZepsEltFree| frees then it.
   }
   */
#include <stdio.h>
#include "zeps.h"

/* \TEX{
   \title{Creation.}
   \input{A finite ring |Rg| and a pointer on a |ZENElt|.}
   \output{0 if no error occurred, |ZENERR| otherwise.}
   }
   */
int _ZepsEltCreate(a, Rg)
     ZENElt *a;
     ZENRing Rg;
{
  return(ZepsEltCreate(*a, Rg));
}

/* \TEX{
   \title{Free.}
   \input{a |ZENElt| |a| of a finite ring |Rg| already allocated with
   |_ZepsEltCreate|.}
   \side{|a| is freed.}
   }
   */
void _ZepsEltFree(a, Rg)
     ZENElt a;
     ZENRing Rg;
{ 
  ZepsEltFree(a, Rg);
}

