/*
 * zen/zeps/c/elt_test.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* \TEX{
   \Subsection{Element tests}
   
   Three functions are provided to do tests: |_ZepsEltAreEqual| to test if two
   |ZENElt| are equal, |_ZepsEltIsZero| to test if a |ZENelt| is equal to
   zero, |_ZepsEltIsOne| to test if a |ZENelt| is equal to one.
   }
   */
#include <stdio.h>
#include "zeps.h"

/* \TEX{
   \title{Equal.}
   \input{Two |ZENElt| |a| and |b| of a finite ring |Rg|.}
   \output{|a| == |b|.}
   }
   */
int _ZepsEltAreEqual(a, b, Rg)
     ZENElt a, b;
     ZENRing Rg;
{
  return(ZepsEltAreEqual(a, b, Rg));
}

/* \TEX{
   \title{Is zero.}
   \input{A |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 0.}
   }
   */
int _ZepsEltIsZero(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZepsEltIsZero(a, Rg));
}

/* \TEX{
   \title{Is one.}
   \input{ |ZENElt| |a| of a finite ring |Rg|.}
   \output{|a| == 1.}
   }
   */
int _ZepsEltIsOne(a, Rg)
     ZENElt a;
     ZENRing Rg;
{
  return(ZepsEltIsOne(a, Rg));
}


