/*
 * zen/zetab/c/doc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*-*-LaTeX-*-
  This is a documentation file of the ZEN library.
  There is no C code in this file, only LaTeX commands.


  \TEX{

    A small finite ring can be cloned using the index representation.
    All the elements |Z| of a |ZENRing| |R| are represented in the
    clone |C| obtained from |R| by the result |(n,nl)| of
    |ZENEltToZ(n,p_nl,Z,R)|. That is to say, each element of a ring is
    ordered by the integer value it takes once evaluated in the
    characteristic.

    Addition, multiplication, negation and inversion are tabulated at
    the initialization.  Therefore, all the subsequent operations will
    take constant time.  The limit size is that of an |unsigned char|,
    that is to say 256 elements.  Polynomials and matrices use also
    the same representation which saves memory
    .  } */

