/*-*-LaTeX-*-
 * zenfact/inputs/intro.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
  This is the documentation file of the whole ZEN library. There is
  no C code in this file, only LaTeX commands.
  
  \TEX{
  \Chapter{Introduction -- Example}
  
  All the procedures described here form the |libzenfact.a|
  library. These procedures are all macros defined in
  |zenfact.h|.
 The installation procedure is the same as that for \zen.

See the ``user manual'' of \zen\ for more details on the following compilation procedure.
     \begin{enumerate}
     \item To decompress |ZENFACT.x.y.tgz| at the same level as |ZMAKE|
       with\\ \$ | gzip -d $<$ ZENFACT.x.y.tgz |$\vert$| tar xvf -|.
     \item To go in the |ZENFACT| directory with\\
       \$ | cd ZENFACT.x.y|.
     \item \label{compilation} To compile with\\
       \$ | make|.
     \item \label{documentation} To get the documentation with\\
       \$ | make doc|.
     \end{enumerate}

The purpose of \zenfact\ is to provide functions that can be used in any |ZENRing|. These functions are generic and do not depend on the representation used. They constitute a good example of what can be done using \zen.

We now give an example of program that use some features of \zenfact, in order to obtain different representations of finite fields. This example can also be used to understand the use of precomputations and clones in \zen.

\input{example}
}
  */
