/*
 * zmake/cf/cyg386.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

#define OSName			Cygwin32

#define OSMajorVersion		20
#define OSMinorVersion		0
#define OSTeenyVersion		0

#define CompilingDir            "cyg386"

#define InstUidFlags		" -s -m 4711"
#define ManSuffix	        "1x"
#define LibManSuffix	        "3x"
#define FileManSuffix	        "5x"

#define Esuf                    ".exe"

#if defined(__GNUC__)
#define HasGcc                  YES
#define HasGccForCplusplus      YES
#define GccUsesGas		YES
#define UseGas			YES
#define GnuCpp			YES

#define HasSockets		YES

#define ArAddOption             " rus"
#define DoRanlibCmd             NO

#define CcCmd			"gcc"
#define CppCmd			"/lib/cpp"
#define YaccCmd			"bison -y"
#define LexCmd			"flex -l"
#define LexLib			" -lfl"
#define LdCombineFlags		" -r"

#ifdef __i486__
# define OptimizedCDebugFlags	" -O -fomit-frame-pointer -m486"
#else 
# define OptimizedCDebugFlags	" -O -fomit-frame-pointer"
#endif

#define StandardDefines		" -Dcygwin386"
#define StandardCppDefines	StandardDefines

#define zopen(path)   open((path), O_BINARY|O_RDONLY)
#define zcreat(path)  open((path), O_BINARY|O_CREAT|O_WRONLY|O_TRUNC, 0666)
#define zfcreat(path) fopen(path, "wb")
#define zfopen(path)  fopen(path, "rb")

#endif
