/*
 * zmake/cf/sun.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

#ifdef sparc

#ifdef __SVR4
# ifndef SystemV4
#  define SystemV4 YES
# endif
#endif

#if defined(SystemV4)
#define OSName            Solaris

#define OSMajorVersion    5
#define OSMinorVersion    5
#define OSTeenyVersion    0

#define CompilingDir      "solarissparc"
#define StandardDefines   " -Dsolarissparc"
#else
#define OSName            SunOS

#define OSMajorVersion    4
#define OSMinorVersion    1
#define OSTeenyVersion    3

#define CompilingDir      "sunossparc"
#define StandardDefines   " -Dsunossparc"
#endif

#define StandardCppDefines	StandardDefines

#define ManSuffix	        "1x"
#define LibManSuffix	        "3x"
#define FileManSuffix	        "4"

#define HasSockets		YES

#if defined(__GNUC__)
#define HasGcc                  YES
#define HasGccForCplusplus      YES

# define CcCmd			"gcc"

# define ThreadsDefines   " -D_REENTRANT"
# define ThreadsLibs " -lthread"
# define ExtraLibraries   " -lsocket -lnsl"
# define OptimizedCDebugFlags " -O2 -mv8"
#else

# define CcCmd			"cc"
# define CIsAnsi     NO

#if defined(__SUNPRO_C)

# if OSMajorVersion > 4
# define ExtraLibraries   " -lsocket -lnsl"
# define ThreadsDefines   " -mt"
# define ProtoDefines     ""

#  if UseLongLong
/* Incredible bug for register long long types on SUN cc 3.0.1, this
   is the only easy patch for this */
#   define DefaultCCOptions " -Xa -Dregister="
#  else
#   define DefaultCCOptions " -Xa"
#  endif
#  define OptimizedCDebugFlags " -fast -native"
#  if ProfilingCode
#    define ProfiledCDebugFlags " -xF"
#  endif
# else
#  define ThreadsDefines       " -D_REENTRANT"
#  define ThreadsLibs     " -lthread"

#  define DefaultCCOptions     " -pipe"
#  define OptimizedCDebugFlags " -O4"
# endif

#else
#  define ThreadsDefines       " -D_REENTRANT"
#  define ThreadsLibs     " -lthread"

#  define DefaultCCOptions     " -pipe -Dstatic= -Dconst= -Dsize_t=unsigned"
#  define OptimizedCDebugFlags " -O4"
#endif
#endif

#if defined(SystemV4)
# define AsCmd	   "/usr/ccs/bin/as -P -T"
# define ArCmdBase "/usr/ccs/bin/ar"
# define CppCmd    "/usr/ccs/lib/cpp"
# define YaccCmd   "/usr/ccs/bin/yacc"
#endif

#endif
