/*-*-LaTeX-*-
 * zmake/doc/doc.c
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
  This is the documentation file of the whole ZEN library. There is
  no C code in this file, only LaTeX commands.


   \TEX{
   \input{title}
   \thispagestyle{headings}
   
   \tableofcontents  

   \Chapter{Introduction}
   \input{intro}
   
   \vspace*{1cm}
   \noindent \underline{Remark~:}
   Except the original way we process the |LaTeX|~\cite{latex}
   documentation, this work about portable compilation and version
   control of sources with |CVS|~\cite{cvs} inherit in parts from the
   programming environment work used by the |LiPS|
   project~\cite{lips}.
   
   \Chapter{Makefiles are not portable}
   \label{makefiles}
   \input{compile}

   \Chapter{Writing |zmake.c| files}
   \label{apis}

   Basically, a |zmake| command is the compilation of a |zmake.c| C
   file which contains a single |main()| procedure calling few |zmake|
   API. These API are described here.

   \nopagebreak[4]

   \input{hzmake}
   \input{ztools}
   \input{zrules}
   
   \Chapter{The documentation parser}
   \label{zparse}
   \input{zparse}

   \Chapter{A |zmake.c| example}
   \label{zmake}

   This example is the |zmake.c| source used to compile this
   documentation.

   \input{zmake}

   \input{biblio}
}
*/
