/*
 * zmake/site.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*****************************************************************************
 *                                                                           *
 *			   SITE-SPECIFIC DEFINITIONS                         *
 *                                                                           *
 *****************************************************************************/

/* \TEX{ It is possible to configure the compiler options you need for
   your convenience.  The file used for that is {\sl site.h} in
   |zmake|.  It contains a few flags that can be set to |YES| or |NO|
   in order to activate or not the corresponding feature.  This file
   is read at the very beginning of the compilation sequence by the
   |zmake|. Therefore, it should be edited before this command.  The
   following are the compilation flags defined:

   \begin{center}
   \begin{tabular}{cp{0.6\textwidth}}
   } */
#define OptimizingCode YES 	/* \TEX{ |OptimizingCode| &
				   use the compiler optimizer, and skip
				   some parts of testing code inside
				   the library
				   \\ } */
#define DebuggingMalloc NO	/* \TEX{ |DebuggingMalloc| &
				   use debugging features like
				   |-fbounds-checking| or Purify.
				   \\ } */
#define ProfilingCode NO	/* \TEX{ |ProfilingCode| &
				   use the compiler profiling options
				   \\ } */
#define UseAssembler YES	/* \TEX{ |UseAssembler| &
				   use the assembler opcodes
				   whenever it's possible
				   \\ } */
#define UseLongLong NO		/* \TEX{ |UseLongLong| &
				   use the long long type if available
				   \\ } */
#define ExpandingNames YES	/* \TEX{ |ExpandingNames| &
				   output filenames can indicate which of
				   the options where used. This is
				   useful especially if you want to keep
				   a debugging and an optimized version of
				   the library
				   \\ } */
# define HasPurify NO		/* \TEX{ |HasPurify| &
				   If you intend to use Purify, you can
				   raise this flag. Otherwise
				   |-fbounds-checking| is used with |gcc|.
				   This flag is only significant when
				   |DebuggingMalloc| is raised.
				   \\ } */
#define HasOMP NO               /* \TEX{ |HasOMP| & If you intend to
				   use compile C Open MP programs, you
				   can raise this flag.  \\ } */
#define HasLargeTmp YES		/* \TEX{ |HasLargeTmp| & large tmp is
                                   available \\ } */



/*
   \TEX{
   \end{tabular}
   \end{center}
   } 
   */
