/*
 * zmake/variable.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/* 
 * Global variables defined by zmake must be declared there.
 * DEFINES, INCLUDES, LOCAL_LDFLAGS, LOCAL_LIBRARY, argc, argv
 * are supposed to already defined.
 */

  /* zmake path */
               _I(PATHSEP, PathSeparator);
               _I(TOP_DIR, TOPDIR);
           _I(CURRENT_DIR, CURDIR);
             _I(ZMAKE_DIR, ZCFDIR);

  /* system constants */
               _I(INCROOT, IncRoot);
             _I(USRLIBDIR, UsrLibDir);
                _I(MANDIR, ManDir);
             _I(MANSUFFIX, ManSuffix); /* suffix for command man pages */
          _I(LIBMANSUFFIX, LibManSuffix); /* suffix for library man pages */
         _I(FILEMANSUFFIX, FileManSuffix); /* suffix for config file man pages */
  
		  _I(YSUF, Ysuf);
		  _I(LSUF, Lsuf);
		  _I(CSUF, Csuf);
		  _I(HSUF, Hsuf);
                  _I(OSUF, Osuf);
                  _I(ASUF, Asuf);
		  _I(ESUF, Esuf);
		  _I(BSUF, Bsuf);
		_I(TEXSUF, TEXsuf);
		_I(DVISUF, DVIsuf);

  /* cpp */
                   _I(CPP, CppCmd);
         _I(PREPROCESSCMD, PreProcessCmd);
       _I(STD_CPP_DEFINES, StandardCppDefines);  
  
  /* cc */
                    _I(CC, CcCmd);
  
           _I(STD_DEFINES, StandardDefines);
         _I(EXTRA_DEFINES, ExtraDefines);
         _I(PROTO_DEFINES, ProtoDefines);
       _I(THREADS_DEFINES, ThreadsDefines);
#if !HasVoidSignalReturn
        _I(SIGNAL_DEFINES, "-DSIGNALRETURNSINT");
#endif

          _I(TOP_INCLUDES, concat(" -I", TOP_DIR));
          _I(ZCF_INCLUDES, concat(" -I", ZMAKE_DIR));
        _I(EXTRA_INCLUDES, ExtraIncludes);
          _I(STD_INCLUDES, StandardIncludes);

           _I(CDEBUGFLAGS, DefaultCDebugFlags);
#if ProfilingCode
           _I(CDEBUGFLAGS, concat(CDEBUGFLAGS, ProfiledCDebugFlags));
#endif
#if DebuggingMalloc
           _I(CDEBUGFLAGS, concat(CDEBUGFLAGS, MallocCDebugFlags));
#endif

             _I(CCOPTIONS, DefaultCCOptions);
        _I(THREADS_CFLAGS, ThreadsCFlags);
            _I(OMP_CFLAGS, OMPCFlags);

      _I(EXTRA_LOAD_FLAGS, ExtraLoadFlags);
       _I(EXTRA_LDOPTIONS, ExtraLoadOptions);
         _I(OMP_LDOPTIONS, OMPLoadOptions);

       _I(THREADS_LDFLAGS, ThreadsLdFlags);
  
         _I(ALLINCLUDES, concat(INCLUDES, concat(TOP_INCLUDES, concat(EXTRA_INCLUDES, STD_INCLUDES))));

            _I(ALLDEFINES, concat(ALLINCLUDES, concat(STD_DEFINES, concat(EXTRA_DEFINES, concat(PROTO_DEFINES, DEFINES)))));

                _I(CFLAGS, concat(CDEBUGFLAGS, 
			      concat(CCOPTIONS, ALLDEFINES)));

           _I(ZCFINCLUDES, concat(TOP_INCLUDES, concat(ZCF_INCLUDES, concat(EXTRA_INCLUDES, STD_INCLUDES))));
            _I(ZCFDEFINES, concat(ZCFINCLUDES, concat(STD_DEFINES, concat(EXTRA_DEFINES, PROTO_DEFINES))));
             _I(ZCFCFLAGS, concat(CCOPTIONS, ZCFDEFINES));

  /* lint */
                  _I(LINT, LintCmd);
           _I(LINTLIBFLAG, LintLibFlag);
              _I(LINTOPTS, LintOpts);

             _I(LINTFLAGS, concat(LINTOPTS, concat(" -DLINT", ALLDEFINES)));

  /* c++ */
#if HasCplusplus
                   _I(CXX, CplusplusCmd);

        _I(CXXSTD_DEFINES, CplusplusStandardDefines);
    _I(THREADS_CXXDEFINES, CplusplusThreadDefines);
      _I(CXXEXTRA_DEFINES, CplusplusExtraDefines);
  
     _I(CXXEXTRA_INCLUDES, CplusplusExtraIncludes);
       _I(CXXIDL_INCLUDES, concat(concat("-I", TOP_DIR), "/include"));

         _I(CXXDEBUGFLAGS, DefaultCplusplusDebugFlags);
      _I(THREADS_CXXFLAGS, CplusplusThreadFlags);
            _I(CXXOPTIONS, CplusplusOptions);

           _I(CXXINCLUDES, concat(INCLUDES,concat(TOP_INCLUDES,concat(CXXEXTRA_INCLUDES,CXXIDL_INCLUDES))));

            _I(CXXDEFINES, concat(CXXINCLUDES,concat(CXXSTD_DEFINES,CXXEXTRA_DEFINES)));

              _I(CXXFLAGS, concat(CXXDEBUGFLAGS, concat(CXXOPTIONS, CXXDEFINES)));
#endif

  /* as */
                    _I(AS, AsCmd);

  /* ar */
                    _I(AR, concat(ArCmdBase, ArCreateOption));
                 _I(ARADD, concat(ArCmdBase, ArAddOption));
                  _I(ARRM, concat(ArCmdBase, ArRmOption));

  /* ranlib */
#if DoRanlibCmd
                _I(RANLIB, RanlibCmd);
       _I(RANLIBINSTFLAGS, RanlibInstFlags);
#endif  

  /* ld */
                    _I(LD, LdCmd);
	  _I(MATH_LIBRARY, MathLibrary);
       _I(EXTRA_LIBRARIES, ExtraLibraries);
         _I(SYS_LIBRARIES, SysLibraries);
          _I(THREADS_LIBS, ThreadsLibs);
              _I(LDPRELIB, LdPreLib);
             _I(LDPOSTLIB, LdPostLib);
          _I(LDSTRIPFLAGS, LdStripFlags);
        _I(LDCOMBINEFLAGS, LdCombineFlags);

             _I(LDOPTIONS, concat(CDEBUGFLAGS, concat(CCOPTIONS, concat(EXTRA_LDOPTIONS, concat(LOCAL_LDFLAGS, LDPRELIB)))));
#if HasCplusplus
          _I(CXXLDOPTIONS, concat(CDEBUGFLAGS, concat(CXXOPTIONS, concat(EXTRA_LDOPTIONS, concat(LOCAL_LDFLAGS, LDPRELIB)))));
#endif
               _I( LDLIBS, concat(LOCAL_LIBRARY, concat(LDPOSTLIB, concat(SYS_LIBRARIES, EXTRA_LIBRARIES))));

          _I(ZCFLDOPTIONS, concat(ZCFCFLAGS, concat(EXTRA_LDOPTIONS, LDPRELIB)));
             _I(ZCFLDLIBS, concat(LDPOSTLIB, concat(SYS_LIBRARIES, EXTRA_LIBRARIES)));

  /* install */
               _I(INSTALL, InstallCmd);
          _I(INSTALLFLAGS, InstallFlags);
          _I(INSTPGMFLAGS, InstPgmFlags);	/* install flags for stripping */
          _I(INSTBINFLAGS, InstBinFlags);	/* install flags for programs */
          _I(INSTUIDFLAGS, InstUidFlags);	/* install flags for setuid programs */
          _I(INSTLIBFLAGS, InstLibFlags);	/* install flags for libraries */
          _I(INSTINCFLAGS, InstIncFlags);	/* install flags for headers */
          _I(INSTMANFLAGS, InstManFlags);	/* install flags for man pages */
          _I(INSTDATFLAGS, InstDatFlags);	/* install flags for data files */

  /* misc */
                   _I(AWK, AwkCmd);
               _I(CTANGLE, CtangleCmd);
              _I(HYCWEAVE, HycweaveCmd);
                 _I(LATEX, LatexCmd);
             _I(MAKEINDEX, MakeIndexCmd);
                   _I(LEX, LexCmd);
                _I(LEXLIB, LexLib);
                  _I(YACC, YaccCmd);
                _I(CCYACC, CplusplusYaccCmd);
                 _I(TROFF, TroffCmd);
              _I(MSMACROS, MsMacros);
#if HasPurify
                _I(PURIFY, PurifyCmd);
         _I(PURIFYOPTIONS, PurifyOptions);
#endif
                 _I(ZMAKE, ZMakeCmd);

               _I(ARCHDIR, CompilingDir);

#if OptimizingCode
	       _I(NAME_OC, "o");
#else
	       _I(NAME_OC, "");
#endif

#if DebuggingMalloc
	       _I(NAME_DM, "g");
#else
	       _I(NAME_DM, "");
#endif

#if ProfilingCode
	       _I(NAME_PC, "p");
#else
	       _I(NAME_PC, "");
#endif

	       _I(NAME_CC, CC);

#if UseAssembler
	       _I(NAME_AS, "");
#else
	       _I(NAME_AS, "c");
#endif

#if UseLongLong
	       _I(NAME_LL, "l");
#else
	       _I(NAME_LL, "");
#endif

#if ExpandingNames
       _I(PREFIX, concat(concat(concat(concat(concat(concat(NAME_CC, NAME_OC), NAME_DM), NAME_PC), NAME_AS), NAME_LL), "_"));
#else
	       _I(PREFIX, "");
#endif
