/*
 * zmake/zconfig.h
 *
 * Copyright (C) 2000 Florent Chabaud and Reynald Lercier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 */

/*
 * To add support for another platform:
 * 
 *     1.  Identify a machine-specific cpp symbol.
 *
 *     2.  Add a new #ifdef block below that defines MacroIncludeFile and
 *         MacroFile for your new platform.
 *
 *     3.  Create a .cf file with the name given by MacroFile.
 */

/* i386, linux */
#if defined(i386) && defined(linux)
# define MacroIncludeFile "cf/linux386.h"
#endif

/* i386, cygnus */
#if defined(__CYGWIN32__)
# define MacroIncludeFile "cf/cyg386.h"
#endif

/* Digital */
#if defined(__osf__) || defined(__alpha)
# define MacroIncludeFile "cf/osf.h"
#endif

/* SUN */
#ifdef sun
# define MacroIncludeFile "cf/sun.h"
#endif

/* HP */
#ifdef __hpux
# define MacroIncludeFile "cf/hp.h"
#endif

/* IBM */
#if defined(_AIX32) && defined(_IBMR2)
# define MacroIncludeFile "cf/aixrs6000.h"
#endif

/* Defaults, cross your fingers ... */
#ifndef MacroIncludeFile
# define MacroIncludeFile "cf/noop.h"
#endif
